"""
Test and demo file for the helper module
"""
import time
import logging
import WebFrame as WF
from WebFrame import handler
from WebFrame import template
from WebFrame.Helper import sql

def hlp_sql(ctx):
    dbh = WF.open_db()

    q = sql.make_delete("Test", {"prim":1})
    ctx.resp.write(q+"<br />")
    dbh.simple(q)

    q = sql.make_delete("Test", allrows=True)
    ctx.resp.write(q+"<br />")
    dbh.simple(q)
    
    q = sql.make_insert("Test",
                        { "a":"first",
                          "b":2,
                          "c":3,
                          "prim":2 })
    ctx.resp.write(q+"<br />")
    dbh.simple(q)

    q = sql.make_insert("Test",
                        { "a":"second",
                          "b":2,
                          "c":3,
                          "prim":1 }, ignore=True)
    ctx.resp.write(q+"<br />")
    dbh.simple(q)

    q = sql.make_insert("Test",
                        { "a":"third",
                          "b":2,
                          "c":3,
                          "prim":1 }, ignore=True,
                        duplicate_key_update=True)
    ctx.resp.write(q+"<br />")
    dbh.simple(q)


    q = sql.make_update("Test", { "a":"upd",
                                  "b":2,
                                  "c":3 },
                        allrows=True)
    ctx.resp.write(q+"<br />")
    dbh.simple(q)

    q = sql.make_update("Test",
                        { "a":1,
                          "b":2,
                          "c":3 },
                        { "k1":"12",
                          "k2":22,
                          "k3":None })
    ctx.resp.write(q+"<br />")
    dbh.simple(q)

    q = sql.make_replace("Test",
                         { "a":"replace",
                           "b":2,
                           "c":3,
                           "prim":1})
    ctx.resp.write(q+"<br />")
    dbh.simple(q)

    
    return ctx.resp.stop_processing()
handler.register_plain("ANY", "/helper/sql", ".*", hlp_sql,
                       "@public", "@deny")

